/**
 * @copyright bLife 2018
 */
class CntTomato {
    init() {
        $('html').unbind();
        $('html').css({"overflow": "hidden"});
        this.clear();
        this.panel = $("<div>").attr("id", "tmp_panel").attr('class', "tmp_weapon_list");
        $("html").append(this.panel);

        this.closeButton();
        this.resetButton();
        this.likeButtons();
        this.soundButton();

        this.initWeapon();


        this.initOtherWeapons();

        $("html").on("mousemove", function (e) {
            $('#tmt_weapon').css({
                'top': e.pageY + this.yShift,
                'left': e.pageX + this.xShift
            });
            this.x = e.pageX;
            this.y = e.pageY;
            $('#tmt_cursor').css({
                'top': e.pageY - 8,
                'left': e.pageX - 8
            });
            this.x = e.pageX;
            this.y = e.pageY;
        }.bind(this));

        $('html').on('mousedown', function (e) {
            event.preventDefault();
            let idEl = ($(event.target).attr("id"));
            switch (idEl) {
                case 'tmt_close':
                case 'tmt_sound_button':
                case 'tmt_like':
                case 'tmt_reset':
                case 'tmt_weapon1':
                case 'tmt_weapon2':
                case 'tmt_weapon3':
                case 'tmt_weapon4':
                case 'tmt_weapon5':
                    e.preventDefault();
                    return;
            }
            if (e.button == 0 && $(event.target).attr("id") != "tmt_close" || $(event.target).attr("id") != "tmt_mouseDisable" || $(event.target).attr("id") != "tmt_reset" || $(event.target).attr("id") != "tmt_sound_button") {
                this.countShoot = 0;
                this.shoot();
            }
        }.bind(this));

        $('html').on('mouseup', function (e) {
            event.preventDefault();
        }.bind(this));

        $('#tmt_mouseDisable').on('focus', function (e) {
            e.preventDefault();
        }.bind(this))
    }

    constructor() {
        this.count = 0;
        this.holes = [];
        this.intervals = [];
        this.x = 0;
        this.y = 0;

        this.fireTime = 1000;
        this.shootRate = 2000;
        this.cs = 0;
        this.xShift = 200;
        this.yShift = 190;

        this.holeX = 210;
        this.holeY = 210;

        this.holeWidth = 210;
        this.holeHeight = 210;

        this.weapon = chrome.extension.getURL('img/tomato.png');
        this.weapon_action = chrome.extension.getURL('img/tomato_a.png');
        this.weapon_fire = chrome.extension.getURL('img/gran_a.png');
        this.sound = chrome.extension.getURL('audio/tomato.mp3');
        this.cursorURL = chrome.extension.getURL('img/t_cursor.png');

    }

    clear() {
        $('#tmt_overlay').remove();
        $('#tmt_weapon').remove();
        $('#tmp_panel').remove();
        $('html').unbind();
    }

    initWeapon() {
        $('html').css({'cursor': 'none'});


        this.overlay = document.createElement('div');
        this.overlay.setAttribute('id', 'tmt_overlay');
        $('body').append(this.overlay);

        this.image = document.createElement('img');
        this.image.setAttribute("id", "tmt_weapon");
        this.image.setAttribute('src', this.weapon);

        $('html').append(this.image);

        $('#tmt_weapon').css({
            'position': 'absolute',
            'z-index': '99999'
        });

        $('html').append(`<div id="tmt_cursor"></div>`);
        $('#tmt_cursor').css({
            'position': 'absolute',
            'z-index': '9999999',
            'width': '50px',
            'height': '50px',
            'background': `url(${this.cursorURL}) no-repeat 0 0`
        });
    }

    closeButton() {
        $('#tmp_panel').append(`<div id="tmt_close" class="tmt_item" title="Close"></div>`);
        $("#tmt_close").on("click", function () {
            this.exit2();
        }.bind(this));
    }

    resetButton() {
        $('#tmp_panel').append($("<div id='tmt_reset' class='tmt_item' title='Reset'></div>"));
        $("#tmt_reset").bind("click", this.reset.bind(this));
    }

    soundButton() {
        let sb = $('<div>').attr("id", "tmt_sound_button").attr("class", 'tmt_item').attr("title", "Sound On/Off");
        $('#tmp_panel').append(sb);
        chrome.extension.sendRequest({get_sound: true}, function (response) {
            this.soundOff = response;
            if (this.soundOff) {
                $("#tmt_sound_button").css('background-image', `url(${chrome.extension.getURL('img/sound_off.png')})`);
            } else {
                $("#tmt_sound_button").css('background-image', `url(${chrome.extension.getURL('img/sound_on.png')})`);
            }
            $("#tmt_sound_button").on("click", function () {
                if (this.soundOff) {
                    this.soundOff = false;
                    $("#tmt_sound_button").css('background-image', `url(${chrome.extension.getURL('img/sound_on.png')})`);
                    chrome.extension.sendRequest({set_sound: 'on'}, (res) => {
                    });
                } else {
                    this.soundOff = true;
                    $("#tmt_sound_button").css('background-image', `url(${chrome.extension.getURL('img/sound_off.png')})`);
                    chrome.extension.sendRequest({set_sound: 'off'}, (res) => {
                    });
                }
            }.bind(this));
        }.bind(this));
    }

    likeButtons() {
        let like = $(`<div>`).attr('id', 'tmt_like').attr('class', 'tmt_like tmt_item').attr("title", "Rate 5 stars");
        $('#tmp_panel').append(like);
        $("#tmt_like").on('click', function () {
            chrome.extension.sendRequest({open_page: true}, (res) => {});
            chrome.storage.local.set({is_click_rate: true});
        }.bind(this));
    }

    exit(event) {
        $("#tmp_panel").remove();
        chrome.extension.sendRequest({exit: true}, (res) => {});
        event.preventDefault();
    };

    exit2() {
        $("#tmp_panel").remove();
        chrome.extension.sendRequest({exit: true}, (res) =>{});
        window.location.reload();
    }

    reset() {
        for (let i = 0; i < this.holes.length; i++) {
            this.holes[i].remove();
        }
        for (let i = 0; i < this.intervals.length; i++) {
            clearInterval(this.intervals[i]);
        }
    }


    shoot() {
        chrome.extension.sendRequest({count_tomato: this.count}, function (response) {
        });
        if (!this.soundOff) {
            let audio = new Audio(this.sound);
            audio.play();
        }
        $('#tmt_weapon').attr('src', this.weapon_fire);
        let hole = document.createElement('div');
        hole.setAttribute('id', 'tmt_hole' + this.count);

        hole.style.position = 'absolute';
        hole.style.top = (this.y + this.holeY) + 'px';
        hole.style.left = (this.x + this.holeX) + 'px';
        hole.style.zIndex = '99998';

        $('html').append(hole);

        let imageSrc;
        imageSrc = this.weapon;
        setTimeout(function () {
            this.moveKnifeFire(hole);
        }.bind(this), 1);


        $('#tmt_hole' + this.count++).css({
            'width': this.holeWidth,
            'height': this.holeHeight,
            'background-image': 'url(' + imageSrc + ')',
            'background-repeat': 'no-repeat',
        });

        setTimeout(function () {
            $('#tmt_weapon').attr('src', this.weapon);
        }.bind(this), this.fireTime);

        if (this.imgCount > 4)
            this.imgCount = 1;

        this.holes.push(hole);
        this.countShoot++;
        let scale = 1;
        this.cs++;
        chrome.storage.local.get(null, function (items) {
            if(items.is_click_rate){

            } else {
                if(this.cs > 15){
                    setInterval(function(){
                        scale = scale == 1 ? 1.1 : 1;
                        $('#tmt_like').css('transform', 'scale('+scale+')')
                    }, 900);
                }
            }
        }.bind(this))
    }

    moveKnifeFire(el) {
        let hole = $(el),
            i = 0,
            rotate = 0,
            left = parseInt(hole.css('left').replace('px', '')) + 100,
            top = parseInt(hole.css('top').replace('px', '')),
            interval = setInterval(function () {
                i++;
                if (i > 50) {
                    hole.remove();
                    clearInterval(interval);
                    left -= 0;
                    top -= -50;
                    let rotHole = 150 + Math.floor(Math.random() * 70);
                    let exp = $('<div style="-webkit-transform:rotate(' + rotHole + 'deg);width:210px;height:210px;position:absolute;left:' + left.toString() + 'px;top:' + top.toString() + 'px;z-index:99998;background:url(' + this.weapon_action + ') no-repeat center center;  "></div>');
                    $('html').append(exp);
                    this.holes.push(exp);
                }
                if (i < 13) {
                    left -= 6;
                    top -= 10;
                } else if (i < 27) {
                    left -= 8;
                    top -= 8;
                } else {
                    left -= 10;
                    top -= 6;
                }
                rotate -= 10;
                if (rotate < 0) {
                    rotate = 350;
                }
                hole.css({
                    '-webkit-transform': `rotate(${rotate}deg)`,
                    'left': left.toString() + 'px',
                    'top': top.toString() + 'px'
                });

            }.bind(this), 15);
    }

    initOtherWeapons() {
        $("#tmt_weapon1").remove();
        $("#tmt_weapon2").remove();
        $("#tmt_weapon3").remove();
        $("#tmt_weapon4").remove();

        let weapon1 = $("<div>").attr("id", "tmt_weapon1").attr("class", "tmt_weapon tmt_item").attr("title", "Tomato"),
            weapon2 = $("<div>").attr("id", "tmt_weapon2").attr("class", "tmt_weapon tmt_item").attr("title", "Slime"),
            weapon3 = $("<div>").attr("id", "tmt_weapon3").attr("class", "tmt_weapon tmt_item").attr("title", "Egg"),
            weapon4 = $("<div>").attr("id", "tmt_weapon4").attr("class", "tmt_weapon tmt_item").attr("title", "Banana");

        $("#tmp_panel").append(weapon1).append(weapon2).append(weapon3).append(weapon4)


        $("#tmt_weapon1").on("click", function () {
            this.weapon = chrome.extension.getURL('img/tomato.png');
            this.weapon_action = chrome.extension.getURL('img/tomato_a.png');
            this.weapon_fire = chrome.extension.getURL('img/gran_a.png');
            this.sound = chrome.extension.getURL('audio/tomato.mp3');
            this.cursorURL = chrome.extension.getURL('img/t_cursor.png');
            $('#tmt_weapon').attr('src', this.weapon);
        }.bind(this));

        $("#tmt_weapon2").on("click", function () {
            this.weapon = chrome.extension.getURL('img/slime.png');
            this.weapon_action = chrome.extension.getURL('img/slime_a.png');
            this.weapon_fire = chrome.extension.getURL('img/gran_a.png');
            this.sound = chrome.extension.getURL('audio/slime.mp3');
            this.cursorURL = chrome.extension.getURL('img/t_cursor.png');
            $('#tmt_weapon').attr('src', this.weapon);
        }.bind(this));

        $("#tmt_weapon3").on("click", function () {
            this.weapon = chrome.extension.getURL('img/egg.png');
            this.weapon_action = chrome.extension.getURL('img/egg_a.png');
            this.weapon_fire = chrome.extension.getURL('img/gran_a.png');
            this.sound = chrome.extension.getURL('audio/egg.mp3');
            this.cursorURL = chrome.extension.getURL('img/t_cursor.png');
            $('#tmt_weapon').attr('src', this.weapon);
        }.bind(this));

        $("#tmt_weapon4").on("click", function () {
            this.weapon = chrome.extension.getURL('img/banana.png');
            this.weapon_action = chrome.extension.getURL('img/banana_a.png');
            this.weapon_fire = chrome.extension.getURL('img/gran_a.png');
            this.sound = chrome.extension.getURL('audio/banana.mp3');
            this.cursorURL = chrome.extension.getURL('img/t_cursor.png');
            $('#tmt_weapon').attr('src', this.weapon);
        }.bind(this));


    }
}

$(function () {
    let cnt = new CntTomato();
    cnt.init();
    window.vnt = true;
});
