/**
 * @author Blife Team
 * @year 2018-2021
 * @copyright Blife Team 2018-2021
 */
class Bg{
    constructor(){
        chrome.runtime.onInstalled.addListener(function (details) {
            if (details.reason == "install") {
                chrome.storage.local.set({
                    count_tomato: 0,
                    data: [],
                    installed: (new Date()).getTime(),
                    uid: this.generetUID()
                });
                chrome.tabs.create({url: 'http://blife-team.com/'})
            } else if (details.reason == "update") {
                chrome.storage.local.set({updated: (new Date()).getTime()});
                chrome.tabs.create({url: 'http://blife-team.com/'})

            }
        }.bind(this));

        chrome.storage.local.get(null, function (items) {
            this.config = items;
            if(this.config == null){
                let fdata = {
                    count_tomato: 0,
                    data: [],
                    installed: (new Date()).getTime(),
                    uid: this.generetUID()
                };
                chrome.storage.local.set(fdata);
                this.config = fdata;
            }
            this.init();
        }.bind(this));

        chrome.storage.onChanged.addListener(function(changes, namespace) {
            chrome.storage.local.get(null, function (items) {
                this.config = items;
            }.bind(this));
        }.bind(this));
    }
    init(){
        chrome.browserAction.onClicked.addListener(function (tab) {
            chrome.browserAction.setIcon({path : "assets/icons/enable.png"});
            chrome.browserAction.setBadgeText({text: ""});
            try{
                chrome.tabs.insertCSS(tab.id,{
                    file: 'content.css'
                });
                chrome.tabs.executeScript(tab.id, {file: 'js/jquery.js'});
                chrome.tabs.executeScript(tab.id, {file: 'js/preloader.js'});
                chrome.tabs.executeScript(tab.id, {file: 'js/jquery.mousewheel.js'});
                chrome.tabs.executeScript(tab.id, {file: 'content.js'});
            } catch (e) {}
        });
        chrome.extension.onRequest.addListener(function (request, sender, sendResponse) {
            if(request.open_page){
                chrome.tabs.create({url: `https://chrome.google.com/webstore/detail/${chrome.runtime.id}`})
                return sendResponse({});
            }
            if (request.exit) {
                chrome.tabs.executeScript(sender.tab.id, {
                    code: `$("#tmt_wd_text_loader").remove();$("#tmt_like").remove();$("#tmt_weapon").remove();$("#tmt_stamp").remove();$("#tmt_spray").remove();$("#tmt_reset").remove();$("#tmt_cursor").remove();$("#tmt_close").remove();$("#tmt_sound_button").remove(); $("#tmt_loaderImage").remove();`
                }, function () {
                    chrome.browserAction.setIcon({path : "assets/icons/icon128.png"});
                    chrome.browserAction.setBadgeText({text: ""})
                });
            } else if (request.get_sound) {
                sendResponse(this.config.sound_off);
            } else if (request.set_sound) {
                if (request.set_sound == 'on') {
                    chrome.storage.local.set({'sound_off': false});
                } else {
                    chrome.storage.local.set({'sound_off': true});
                }
            } else if (request.loaded){
                chrome.browserAction.setBadgeText({text: ""})
            } else if (request.count_tomato) {
                chrome.browserAction.setBadgeText({text: `${request.count_tomato}`});

                let count = parseInt(this.config.count_tomato) + 1;
                chrome.storage.local.set({'count_tomato': count});
                chrome.browserAction.setIcon({path : "assets/icons/enable.png"});
            }
        }.bind(this));
    }
    generetUID(){
        let buf = new Uint32Array(4),
            idx = -1;
        window.crypto.getRandomValues(buf);
        let uid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
            idx++;
            let r = (buf[idx >> 3] >> ((idx % 8) * 4)) & 15,
                v = c == 'x' ? r : (r & 0x3 | 0x8);
            return v.toString(16);
        });
        return uid;
    }
}
(function () {
    new Bg();
})();
